﻿Type=Class
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	'Enum Status
	Private status As Int
	Private UNCHANGED As Int=0
	Private INSERTED As Int=1
	Private UPDATED As Int=2
	Private DELETED As Int=3
	
	Private s_description As String
	Private s_description_old As String
	Private s_notes As String
	Private s_notes_old As String
End Sub

'Inittialize Class
Public Sub Initialize(description As String,notes As String)
	status=UNCHANGED

	s_description=description
	s_description_old=description
	s_notes=notes
	s_notes_old=notes

	If s_description_old="" Then status=INSERTED
End Sub

'Turn into Unchanged Status
Public Sub Update
	status=UNCHANGED
	s_description_old=s_description
	s_notes_old=s_notes
End Sub

'Turn into Deleted Status
Public Sub Delete
	status=DELETED
End Sub 

Public Sub Save As Boolean
	'Chack database
	Private db As Database
	db.Initialize

	If getDescription="" Then Return False
	
	Private result As Boolean
	If getIsDeleted Then result=db.ExecuteDML("DELETE FROM Categories WHERE Description=?;",Array As Object(getDescription))
	If getIsNew Then result=db.ExecuteDML("INSERT INTO Categories (Description,Notes) VALUES (?,?);",Array As Object(getDescription,getNotes))
	If getIsModified Then result=db.ExecuteDML("UPDATE Categories SET Notes=? WHERE Description=?;",Array As Object(getNotes,getDescription))
	
	If result Then 
		Update
	Else
		Msgbox("Error on modifying the db.","Category")	
	End If
	
	Return result
End Sub

#Region Property
'Return Description
Sub getDescription As String
	Return s_description	
End Sub
'Set Description
Sub setDescription(value As String)
	s_description=value
End Sub
'Return Notes
Sub getNotes As String
	Return s_notes	
End Sub
'Set Notes
Sub setNotes(value As String)
	s_notes=value
End Sub

'Return If it is a New State
Sub getIsNew As Boolean
	Return (status=INSERTED)
End Sub
'Return If it is a Deleted State
Sub getIsDeleted As Boolean
	Return (status=DELETED)
End Sub 
'Return If it is a Modified State
Sub getIsModified As Boolean
	If status=INSERTED Or status=DELETED Then Return False
	If s_description<>s_description_old Then status=UPDATED
	If s_notes<>s_notes_old Then status=UPDATED
	Return (status=UPDATED)
End Sub

Sub getText As String
	Return getDescription
End Sub
#End Region