﻿Type=StaticCode
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
End Sub

'Upgrade Database schema and preserve data.
'In case of error return False
Public Sub UpgradeDB(db As SQL, tables As Map,versionRequest As Int) As Boolean
	Private cols As Cursor

	Private rep As Boolean: rep=False
	'Verify version
	Try
		If db.ExecQuerySingleResult("PRAGMA user_version")>=versionRequest Then Return True
	Catch
		Log(LastException)
	End Try

	'Perform Upgrade in transaction	
	db.BeginTransaction
	Try
		'Iterate MAP tables
		For Each table As String In tables.Keys
			'Verify if table exist
			If db.ExecQuerySingleResult("SELECT count() FROM sqlite_master WHERE type='table' AND name='" & table & "';")<=0 Then
				'If not exist CREATE 
				db.ExecNonQuery(tables.Get(table))
			Else 'If exist proceed with the update
				'Rename table containing data
				Private oldTable="updating_" & table As String				
				db.ExecNonQuery("ALTER TABLE '" & table & "' RENAME TO '" & oldTable & "';")
				'Create new table without data
				db.ExecNonQuery(tables.Get(table))
								
				'Read all columns name in new table
				Private allColumns As List
				allColumns.Initialize
				cols=db.ExecQuery("PRAGMA table_info('" & table & "');")
				For i=0 To cols.RowCount-1
					cols.Position=i
					allColumns.Add(cols.GetString("name"))
				Next

				'Read columns name in old table
				Private ColumnsToTrasfer As List
				ColumnsToTrasfer.Initialize
				cols=db.ExecQuery("PRAGMA table_info('" & oldTable & "');")
				For i=0 To cols.RowCount-1
					cols.Position=i
					'If column name match in old table and new table stored
					If allColumns.IndexOf(cols.GetString("name")) >= 0 Then ColumnsToTrasfer.Add(cols.GetString("name"))
				Next
				
				'Trasfer data from old table to new table
				Private sql As String
				sql="INSERT INTO " & table & " (" & Implode(",",ColumnsToTrasfer) & ") SELECT " & Implode(",",ColumnsToTrasfer) & " FROM " & oldTable & ";"				
				db.ExecNonQuery(sql)
				'DROP old table
				db.ExecNonQuery("DROP TABLE IF EXISTS '" & oldTable & "'")
			End If 			
		Next
				
		'Update VERSION 
		db.ExecQuerySingleResult("PRAGMA user_version=" & versionRequest)
		
		db.TransactionSuccessful
		rep=True
	Catch
		Log(LastException)
		rep=False		
	End Try
	
	db.EndTransaction
	Return rep
End Sub

Private Sub Implode(glue As String, pieces As List) As String
   Dim result As StringBuilder

   If pieces.Size = 0 Then Return ""
   If pieces.size = 1 Then Return pieces.Get(0)
   
   result.Initialize
   result.Append(pieces.get(0))
   For i=1 To pieces.size-1
      result.Append(glue & pieces.get(i))
   Next
   Return result.ToString
End Sub