﻿Type=Class
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private DBNAME As String="pp.db"
	Public DB As SQL
	Private version As Int=1
End Sub

Public Sub Initialize()
	'Log(File.DirDefaultExternal)

	DB.Initialize(File.DirDefaultExternal,DBNAME,True)
End Sub

Public Sub Open
	If Not(DB.IsInitialized) Then DB.Initialize(File.DirDefaultExternal,DBNAME,True)
End Sub
Public Sub Close
	DB.Close
End Sub

Public Sub Upgrade
	Private m_tables As Map
	m_tables.Initialize
	m_tables.Put("Categories","CREATE TABLE Categories (Description TEXT (40) PRIMARY KEY UNIQUE, Notes TEXT (200));")
	m_tables.Put("Brands","CREATE TABLE Brands (Description TEXT (40) PRIMARY KEY NOT NULL, Notes TEXT (200));")
	m_tables.Put("Shops","CREATE TABLE Shops (Description TEXT (40) NOT NULL PRIMARY KEY, Notes TEXT (200));")
	m_tables.Put("Objects","CREATE TABLE O2B (Description TEXT (40) NOT NULL, Category TEXT (40), MaxScore INTEGER DEFAULT (10), Notes STRING (200), PRIMARY KEY (Description, Category));")
	m_tables.Put("Products","CREATE TABLE Products (Category TEXT (40), Brand TEXT (40), Model TEXT (40), BrandCode TEXT (40), Notes TEXT (200), PRIMARY KEY (Category, Brand, Model));")
	m_tables.put("Features","CREATE TABLE Features (Category TEXT (40), Description TEXT (40), Type TEXT (1) CHECK (Type IN ('P', 'S')));")
	
	If DBVersion.UpgradeDB(DB,m_tables,version)=False Then
		Msgbox("Error on upgrade database" & CRLF & "Application must be closed","Failed upgrade")
		ExitApplication
	Else
		'Load default Data
		Dim count As Int
		count=DB.ExecQuerySingleResult("SELECT count() FROM Categories;")
		If count<=0 Then
			DB.ExecNonQuery2("INSERT INTO Categories (Description,Notes) VALUES (?,?)",Array As Object("Unclassified","Preferably don't use this"))
		End If	
	End If
End Sub

Public Sub BeginTransaction
	DB.BeginTransaction
End Sub

Public Sub CommitTransaction
	DB.TransactionSuccessful
End Sub

Public Sub EndTransaction
	DB.EndTransaction
End Sub

Public Sub GetData(query As String, filter() As String) As Cursor
	If Not(DB.IsInitialized) Then DB.Initialize(File.DirDefaultExternal,DBNAME,True)
	If filter=Null Then
		Return DB.ExecQuery(query)
	Else
		Return DB.ExecQuery2(query,filter)
	End If
End Sub

Public Sub ExecuteDML(query As String, filter() As Object) As Boolean
	Private res As Boolean
	res=False

	If Not(DB.IsInitialized) Then DB.Initialize(File.DirDefaultExternal,DBNAME,True)
	Try
		DB.ExecNonQuery2(query,filter)
		res=True
	Catch
		res=False
	End Try
	Return res
End Sub