﻿Type=Class
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	'Enum Status
	Private status As Int
	Private UNCHANGED As Int=0
	Private INSERTED As Int=1
	Private UPDATED As Int=2
	Private DELETED As Int=3
	
	Private s_category As String
	Private s_brand As String
	Private s_brand_old As String
	Private s_model As String
	Private s_model_old As String
	Private s_brandcode As String
	Private s_brandcode_old As String
	Private s_notes As String
	Private s_notes_old As String
End Sub

'Initialize Class
Public Sub Initialize(category As String,brand As String,model As String,brandcode As String,notes As String)
	status=UNCHANGED

	s_category=category
	s_brand=brand
	s_brand_old=brand
	s_model=model
	s_model_old=model
	s_brandcode=brandcode
	s_brandcode_old=brandcode
	s_notes=notes
	s_notes_old=notes

	If s_brand_old="" And s_model_old="" Then status=INSERTED
End Sub

'Turn into Deleted Status
Public Sub Delete
	status=DELETED
End Sub 

Public Sub Save(database As Database) As Boolean
	'Chack database
	Private db As Database
	If database.IsInitialized Then
		database.Open
		db=database
	Else
		db.Initialize
	End If
	
	Private result As Boolean
	If getIsDeleted Then 
		result=db.ExecuteDML("DELETE FROM Products WHERE Category=? AND Brand=? AND Model=?;",Array As Object(getCategory,getBrand,getModel))
	End If
	If getIsNew Then 
		result=db.ExecuteDML("INSERT INTO Products (Category,Brand,Model,Brandcode,Notes) VALUES (?,?,?,?,?);",Array As Object(getCategory,getBrand,getModel,getBrandCode,getNotes))
	End If
	If getIsModified Then 
		result=db.ExecuteDML("UPDATE Products SET Brandcode=?, Notes=? WHERE Category=? AND Brand=? AND Model=?;",Array As Object(getBrandCode,getNotes,getCategory,getBrand,getModel))
	End If
		
	If result Then Update
	Return result
End Sub

'Turn into Unchanged Status
Private Sub Update
	status=UNCHANGED
	s_brand_old=s_brand
	s_model_old=s_model
	s_brandcode_old=s_brandcode
	s_notes_old=s_notes
End Sub

#Region Property
'Return brand
Sub getCategory As String
	Return s_category
End Sub

Sub getBrand As String
	Return s_brand
End Sub
'Set brand
Sub setBrand(value As String)
	s_brand=value
End Sub

'Return model
Sub getModel As String
	Return s_model
End Sub
'Set model
Sub setModel(value As String)
	s_model=value
End Sub

'Return brandcode
Sub getBrandCode As String
	Return s_brandcode
End Sub
'Set model
Sub setBrandCode(value As String)
	s_brandcode=value
End Sub

'Return Notes
Sub getNotes As String
	Return s_notes	
End Sub
'Set Notes
Sub setNotes(value As String)
	s_notes=value
End Sub

'Return If it is a New State
Sub getIsNew As Boolean
	Return (status=INSERTED)
End Sub
'Return If it is a Deleted State
Sub getIsDeleted As Boolean
	Return (status=DELETED)
End Sub 
'Return If it is a Modified State
Sub getIsModified As Boolean
	If status=INSERTED Or status=DELETED Then Return False
	If s_model<>s_model_old Then status=UPDATED
	If s_brand<>s_brand_old Then status=UPDATED
	If s_brandcode<>s_brandcode_old Then status=UPDATED
	If s_notes<>s_notes_old Then status=UPDATED
	Return (status=UPDATED)
End Sub

Sub getText As String
	Return getBrand & " " & getModel
End Sub
#End Region