﻿Type=Class
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	'Enum Status
	Private status As Int
	Private UNCHANGED As Int=0
	Private INSERTED As Int=1
	Private UPDATED As Int=2
	Private DELETED As Int=3
	
	Private s_description As String
	Private s_description_old As String
	Private s_notes As String
	Private s_notes_old As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(description As String, notes As String)
	status=UNCHANGED

	s_description=description
	s_description_old=description
	s_notes=notes
	s_notes_old=notes

	If s_description_old="" Then status=INSERTED
End Sub

'Turn into Deleted Status
Public Sub Delete
	status=DELETED
End Sub 

Public Sub Save(database As Database) As Boolean
	'Chack database
	Private db As Database
	If database.IsInitialized Then
		database.Open
		db=database
	Else
		db.Initialize
	End If
	
	Private result As Boolean
	If getIsDeleted Then 
		result=db.ExecuteDML("DELETE FROM Shops WHERE Description=?;",Array As Object(getDescription))
	End If
	If getIsNew Then 
		result=db.ExecuteDML("INSERT INTO shops (Description,Notes) VALUES (?,?);",Array As Object(getDescription,getNotes))
	End If
	If getIsModified Then 
		result=db.ExecuteDML("UPDATE shops SET Notes=? WHERE Description=?;",Array As Object(getNotes,getDescription))
	End If
	
	If result Then Update
	Return result
End Sub

'Turn into Unchanged Status
Private Sub Update
	status=UNCHANGED
	s_description_old=s_description
	s_notes_old=s_notes
End Sub

#Region Property
'Return Description
Sub getDescription As String
	Return s_description	
End Sub
'Set Description
Sub setDescription(value As String)
	s_description=value
End Sub
'Return Notes
Sub getNotes As String
	Return s_notes	
End Sub
'Set Notes
Sub setNotes(value As String)
	s_notes=value
End Sub

'Return If it is a New State
Sub getIsNew As Boolean
	Return (status=INSERTED)
End Sub
'Return If it is a Deleted State
Sub getIsDeleted As Boolean
	Return (status=DELETED)
End Sub 
'Return If it is a Modified State
Sub getIsModified As Boolean
	If status=INSERTED Or status=DELETED Then Return False
	If s_description<>s_description_old Then status=UPDATED
	If s_notes<>s_notes_old Then status=UPDATED
	Return (status=UPDATED)
End Sub
#End Region